#ifndef DOMAIN_LIBRARY_POPUP_H
#define DOMAIN_LIBRARY_POPUP_H

#include "rule.h"

#include <map>
#include <string>
#include <vector>


class EnumerationNode: AstNode {
public:
    StringNode key;
    Value value;
};

class Popup: AstNode
{
public:
    enum PopupType {
        AUTOMATIC,
        ON_DEMAND
    };

    PopupType type;
    StringNode title;
    StringNode text;

    bool enumerated;
    std::vector<EnumerationNode> enumeration;

    std::vector<Rule> rules;

    Popup();
};

#endif // DOMAIN_LIBRARY_POPUP_H
